#!/usr/bin/python3
from os import system
import random

# Das ist die Liste in der die Felder für die ausgabe auf der Konsole. Die einzelnen Felder werden durch X oder O
# beim Spiel ersetzt
field = ["",
         "1", "2", "3",
         "4", "5", "6",
         "7", "8", "9"]

player = '\x1b[1;34m' "X" '\x1b[1;0m'  # Die Zeichen X und O werden so farbig ausgegeben.
# Achtung! O hat eine andere Farbe
#player = 'X'
run = True  # Variable, die auf Wahr gesetzt ist, damit das Programm sauber beendet wird.


def player_names1():
    pl_names = True
    while pl_names:
        name_player1 = input("Spieler 1 gib deinen Spielernamen ein.\n")
        if name_player1 == "":
            print("Ups keine gültige eingabe...")
            continue
        else:
            return name_player1
            pl_names = False


def player_names2():
    pl_names = True
    while pl_names:
        name_player2 = input("Spieler 2 gib deinen Spielernamen ein.\n")
        if name_player2 == "":
            print("Ups keine gültige eingabe...")
            continue
        else:
            return name_player2
            pl_names = False


def gamers():
    try:
        while True:
            pl_ai = input(
                "Gegen den Computer spielen,\ndie 1 drücken.\nFür 2 Spieler die 2 drücken.\n")  # pl_ai player or künstliche
            # intelligenz
            pl_ai = int(pl_ai)
            if pl_ai == 1:
                name_player1 = player_names1()
                name_player2 = 'Computer'
                return name_player1, name_player2
            if pl_ai == 2:
                name_player1 = player_names1()
                name_player2 = player_names2()
                return name_player1, name_player2
            else:
                print("Bitte nur 1 oder 2 wählen!")
                continue
    except ValueError:
        print("Bitte nur 1 oder 2 wählen!")
        main()  # Hier steht nachher main() drin!


one_two = gamers()

name_player1 = one_two[0]
name_player2 = one_two[1]


def p_field():  # p_ = print. Damit wird das Spielfeld aus der Liste field auf der Konsole ausgegeben
    print("")
    print("            " + field[1] + "|" + field[2] + "|" + field[3])
    print("            " + field[4] + "|" + field[5] + "|" + field[6])
    print("            " + field[7] + "|" + field[8] + "|" + field[9])
    print("")


def play_now():
    global run
    if player == '\x1b[1;31m' "0" '\x1b[1;0m' and name_player2 == 'Computer':
        field_ai = []
        for i in field:
            if i != '\x1b[1;34m' "X" '\x1b[1;0m' and i != '\x1b[1;31m' "0" '\x1b[1;0m' and i != '':
                # hier wird geprüft, ob das element dem entspricht, was hier angegeben wurde.
                # ist das momentane element ungleich X und ungleich O und ungleich '' also ein anderes element,
                # dann wird es in die liste field_ai hinzugefügt. Info! In der Liste field sind nur Strings!
                field_ai += i
                sel_field = int(random.choice(field_ai))
                # hier wird ein zufälliges element, aus der neu erzeugten liste
                # ausgewählt dieser wird auch gleich in ein integer gecastet und der Variable sel_field zugewiesen
                return sel_field
    else:
        while True:
            try:  # Try eingebaut damit auch alle anderen Zeichen und Buchstaben abgefangen werden.
                sel_field = input("Bitte ein Feld auswählen:\nZum beenden des Spiels q drücken.\n")
                if sel_field == "q":
                    run = False
                    return 1
                if sel_field == "":
                    print("Ohne eingabe kein gewinn!!!")
                    continue
                sel_field = int(sel_field)
                if sel_field >= 1 and sel_field <= 9:
                    if field[sel_field] == '\x1b[1;34m' "X" '\x1b[1;0m' or field[sel_field] == '\x1b[1;31m' "0" '\x1b[1;0m':
                        print("Spielfeld wurde schon ausgewählt!\n")
                    else:
                        return sel_field
                else:
                    print("Bitte nur Ziffern von 1 - 9 wählen!\n")
            except ValueError:
                print("Bitte nur Ziffern von 1 - 9 wählen!\n")


def change_player():  # Prüfung welcher Spieler dran ist. (Funktion Spielerwechsel)
    global player
    if run:
        if player == '\x1b[1;34m' "X" '\x1b[1;0m':
            player = '\x1b[1;31m' "0" '\x1b[1;0m'
            print("Spieler " + name_player2 + " ist dran.")
        else:
            player = '\x1b[1;34m' "X" '\x1b[1;0m'
            print("Spieler " + name_player1 + " ist dran.")


def name_players():
    if field[1] == "1" and field[2] == "2" and field[3] == "3" and field[4] == "4" and field[5] == "5" \
            and field[6] == "6" and field[7] == "7" and field[8] == "8" and field[9] == "9":
        return True


if name_players():
    print("Spieler " + name_player1 + " ist dran.")


def check_win():  # Prüfung ob 3 Felder mit X oder O hintereinander (Horizontal, Waagerecht, Diagonal) belegt sind.
    if field[1] == field[2] == field[3]:
        return field[1]
    if field[4] == field[5] == field[6]:
        return field[4]
    if field[7] == field[8] == field[9]:
        return field[7]
    if field[1] == field[4] == field[7]:
        return field[1]
    if field[2] == field[5] == field[8]:
        return field[2]
    if field[3] == field[6] == field[9]:
        return field[3]
    if field[1] == field[5] == field[9]:
        return field[1]
    if field[3] == field[5] == field[7]:
        return field[3]


def draw_game():  # Diese funktion prüft das Spielfeld auf X oder O also, ob keine Zahlen mehr vorhanden sind.
    if field[1] != "1" and field[2] != "2" and field[3] != "3" and field[4] != "4" and field[5] != "5" \
            and field[6] != "6" and field[7] != "7" and field[8] != "8" and field[9] != "9":
        return True


def main():
    global run
    while run:  # Das ist die Gameloop. Die Schleife wurde hier mit run auf True gesetzt, damit das Spiel sauber
        # beendet wird.
        p_field()
        sel_field = play_now()
        system('clear')  # Hiermit wird das Spielfeld immer wieder an der gleichen Position angezeigt, ohne dies würde
        # das Feld bei jedem Zug nach unten rutschen.
        field[sel_field] = player
        winner = check_win()
        if winner:
            if winner == '\x1b[1;34m' "X" '\x1b[1;0m':
                print("Spieler " + name_player1 + " hat gewonnen.")
                run = False
            if winner == '\x1b[1;31m' "0" '\x1b[1;0m':
                print("Spieler " + name_player2 + " hat gewonnen.")
                run = False
        else:
            if draw_game():
                print("Spiel ist unentschieden...")
                run = False
        change_player()


if __name__ == '__main__':
    main()
